import p2.ui.settings
from p2.tools.driver import get_attr


class Core:

    def __init__(self):
        pass


    def get_css(self):
        css = list()
        for app in p2.ui.settings.REGISTERED_APPS:
            css.extend([ f"/{app}/" + j for j in get_attr(driver=app+".settings",
                                                          module='p2.ui',
                                                          attr_name='CSS')])
        css_as_dict = {k:v for v,k in enumerate(css)}
        return list(css_as_dict.keys())

    def get_js(self):
        js = list()
        for app in p2.ui.settings.REGISTERED_APPS:
            js.extend(get_attr(driver=app+".settings", module='p2.ui', attr_name='JS_LIBS'))
            js.extend([ f"/{app}/" + j for j in get_attr(driver=app+".settings",
                                                            module='p2.ui',
                                                            attr_name='APP_JS')])
        js_as_dict = {k:v for v,k in enumerate(js)}
        return list(js_as_dict.keys())

    def get_menubar(self):
        return [get_attr(driver=app+".settings", module='p2.ui', attr_name='MENU') for
                app in p2.ui.settings.REGISTERED_APPS]
